﻿using GameAtlas.Models;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GameAtlas.DataContractPersistance
{
    public class DataContractPers : IPersistanceManager
    {
        public string FileName { get; set; } = "data.xml";

        public string FilePath { get; set; } = Path.Combine(Directory.GetCurrentDirectory(),"\\XML");

        public (List<Jeu>, List<Utilisateur>) ChargeDonnees()
        {
            var serializer = new DataContractPers(typeof(List<Utilisateur>));

            List<Utilisateur> list;

            using (Stream s = File.OpenRead(Path.Combine(FilePath, FileName)))
            {
                list = serializer.ReadObject(s) as List<Utilisateur>;
            }
            return (new List<Jeu>(), list);
        }

        public void sauvegardeDonnees(List<Jeu> jeux, List<Utilisateur> users)
        {
            var serializer = new DataContractPers(typeof(List<Utilisateur>));

            if(!Directory.Exists(FilePath))
            {
                Debug.WriteLine("Directory crée");
                Debug.WriteLine(Directory.GetDirectoryRoot);
                Debug.WriteLine(FilePath);
                Directory.CreateDirectory(FilePath);
            }

            using (Stream s = File.Create(Path.Combine(FilePath, FileName)))
            {
                serializer.WriteObject(s, users);
            }
        }

        public (List<Jeu>, List<Utilisateur>) chargeDonnees2()
        {
            var serializer = new DataContractPers(typeof(List<Utilisateur>));

            DataToPersist data;
            using (Stream s = File.OpenRead(Path.Combine(FilePath, FileName)))
            {
                data = serializer.ReadObject(s) as DataToPersist;
            }
            return (data.jeux, data.users);
        }
    }
}
